
function scrw_performSearch(selectedText)
{
	if (selectedText == "")
		selectedText = scrw_getSelectedText();

	search_string = encodeURIComponent(selectedText);
	search_url = "https://ssl.scroogle.org/cgi-bin/nbbwssl.cgi?Gw=" + search_string;
	getBrowser().loadOneTab(search_url);
	return true;
}

// most of what is below this line is from StumbleUpon.
function scrw_getSelectedText()
{
	var node = document.popupNode;
	var selection = "";

	if ((node instanceof HTMLTextAreaElement) || (node instanceof HTMLInputElement && node.type == "text"))
	{
		selection = node.value.substring(node.selectionStart, node.selectionEnd);
	} 
	else {
		var focusedWindow = new XPCNativeWrapper(document.commandDispatcher.focusedWindow, 'document', 'getSelection()');
		selection = focusedWindow.getSelection().toString();
	}

	// Limit length to 2048 (http://code.google.com/apis/soapsearch/reference.html#2_7)
	if (selection.length>=2048)
		selection = selection.substring(0, 2047);

	return selection; 
}

function scrw_contextSearch(event) 
{
	if (gContextMenu) 
	{
		// look for selected text
		var selectedText = scrw_getSelectedText();

		if (selectedText != "")
		{
			var stringsBundle = document.getElementById("string-bundle");
			var scrwString = stringsBundle.getString('scrwString') + " ";

			var selectedText2 = selectedText;
			if (selectedText2.length > 15)
				selectedText2 = selectedText.substring(0, 15) + "...";	
			
			menuitem = document.getElementById('context-searchselect');
			menuitem.hidden = true;
			menuitem = document.getElementById('scroogle-with-search');
			menuitem.hidden = false;
			selectedText2 = selectedText;
			if (selectedText2.length > 15)
				selectedText2 = selectedText.substring(0, 15) + "...";	

			menuitem.label = scrwString +'"' + selectedText2 + '"';
		}
		else
		{
			menuitem = document.getElementById('scroogle-with-search');
			menuitem.hidden = true;
		}
	}
}

// handles the window load event
function scrw_handle_window_load()
{
	// Initialize context menu
	var menu = document.getElementById("contentAreaContextMenu");
	menu.addEventListener("popupshowing", scrw_contextSearch, false); 
}

window.addEventListener("load", scrw_handle_window_load, false);
